+#!/bin/sh
# 6to4.sh - IPv6-in-IPv4 tunnel backend
-# Copyright (c) 2010 OpenWrt.org
+# Copyright (c) 2010-2012 OpenWrt.org
+
+[ -n "$INCLUDE_ONLY" ] || {
+ . /etc/functions.sh
+ . ../netifd-proto.sh
+ init_proto "$@"
+}
find_6to4_wanif() {
local if=$(ip -4 r l e 0.0.0.0/0); if="${if#default* dev }"; if="${if%% *}"
printf "2002:%02x%02x:%02x%02x\n" $1 $2 $3 $4
}
-# Hook into scan_interfaces() to synthesize a .device option
-# This is needed for /sbin/ifup to properly dispatch control
-# to setup_interface_6to4() even if no .ifname is set in
-# the configuration.
-scan_6to4() {
- config_set "$1" device "6to4-$1"
+test_6to4_rfc1918()
+{
+ local oIFS="$IFS"; IFS="."; set -- $1; IFS="$oIFS"
+ [ $1 -eq 10 ] && return 0
+ [ $1 -eq 192 ] && [ $2 -eq 168 ] && return 0
+ [ $1 -eq 172 ] && [ $2 -ge 16 ] && [ $2 -le 31 ] && return 0
+ return 1
}
-coldplug_interface_6to4() {
- setup_interface_6to4 "6to4-$1" "$1"
+set_6to4_radvd_interface() {
+ local cfgid="$1"
+ local lanif="${2:-lan}"
+ local ifmtu="${3:-1280}"
+ local ifsection=""
+
+ find_ifsection() {
+ local net
+ local cfg="$1"
+ config_get net "$cfg" interface
+
+ [ "$net" = "$lanif" ] && {
+ ifsection="$cfg"
+ return 1
+ }
+ }
+
+ config_foreach find_ifsection interface
+
+ [ -z "$ifsection" ] && {
+ ifsection="iface_$sid"
+ uci_set_state radvd "$ifsection" "" interface
+ uci_set_state radvd "$ifsection" interface "$lanif"
+ }
+
+ uci_set_state radvd "$ifsection" ignore 0
+ uci_set_state radvd "$ifsection" IgnoreIfMissing 1
+ uci_set_state radvd "$ifsection" AdvSendAdvert 1
+ uci_set_state radvd "$ifsection" MaxRtrAdvInterval 30
+ uci_set_state radvd "$ifsection" AdvLinkMTU "$ifmtu"
}
-setup_interface_6to4() {
- local iface="$1"
- local cfg="$2"
- local link="6to4-$cfg"
+set_6to4_radvd_prefix() {
+ local cfgid="$1"
+ local lanif="${2:-lan}"
+ local wanif="${3:-wan}"
+ local prefix="${4:-0:0:0:1::/64}"
+ local vlt="${5:-300}"
+ local plt="${6:-120}"
+ local pfxsection=""
+
+ find_pfxsection() {
+ local net base
+ local cfg="$1"
+ config_get net "$cfg" interface
+ config_get base "$cfg" Base6to4Interface
+
+ [ "$net" = "$lanif" ] && [ "$base" = "$wanif" ] && {
+ pfxsection="$cfg"
+ return 1
+ }
+ }
+
+ config_foreach find_pfxsection prefix
+
+ [ -z "$pfxsection" ] && {
+ pfxsection="prefix_${sid}_${lanif}"
+ uci_set_state radvd "$pfxsection" "" prefix
+ uci_set_state radvd "$pfxsection" ignore 0
+ uci_set_state radvd "$pfxsection" interface "$lanif"
+ uci_set_state radvd "$pfxsection" prefix "$prefix"
+ uci_set_state radvd "$pfxsection" AdvOnLink 1
+ uci_set_state radvd "$pfxsection" AdvAutonomous 1
+ uci_set_state radvd "$pfxsection" AdvValidLifetime "$vlt"
+ uci_set_state radvd "$pfxsection" AdvPreferredLifetime "$plt"
+ uci_set_state radvd "$pfxsection" Base6to4Interface "$wanif"
+ }
+}
+
+tun_error() {
+ local cfg="$1"; shift;
- local local4=$(uci_get network "$cfg" ipaddr)
+ [ -n "$1" ] && proto_notify_error "$cfg" "$@"
+ proto_block_restart "$cfg"
+}
- local mtu
- config_get mtu "$cfg" mtu
+proto_6to4_setup() {
+ local cfg="$1"
+ local iface="$2"
+ local link="6to4-$cfg"
- local ttl
- config_get ttl "$cfg" ttl
+ json_get_var mtu mtu
+ json_get_var ttl ttl
+ json_get_var local4 ipaddr
- local defaultroute
- config_get_bool defaultroute "$cfg" defaultroute 1
+ json_get_var adv_subnet adv_subnet
+ json_get_var adv_interface adv_interface
+ json_get_var adv_valid_lifetime adv_valid_lifetime
+ json_get_var adv_preferred_lifetime adv_preferred_lifetime
local wanif=$(find_6to4_wanif)
[ -z "$wanif" ] && {
- logger -t "$link" "Cannot find wan interface - aborting"
+ tun_error "NO_WAN_LINK"
return
}
- local wancfg=$(find_config "$wanif")
+ . /lib/network/config.sh
+ local wancfg="$(find_config "$wanif")"
[ -z "$wancfg" ] && {
- logger -t "$link" "Cannot find wan network - aborting"
+ tun_error "NO_WAN_LINK"
return
}
# If local4 is unset, guess local IPv4 address from the
# interface used by the default route.
[ -z "$local4" ] && {
- [ -n "$wanif" ] && {
- local4=$(find_6to4_wanip "$wanif")
- uci_set_state network "$cfg" wan_device "$wanif"
- }
+ [ -n "$wanif" ] && local4=$(find_6to4_wanip "$wanif")
}
- [ -n "$local4" ] && {
- logger -t "$link" "Starting ..."
+ [ -z "$local4" ] && {
+ tun_error "NO_WAN_LINK"
+ return
+ }
- # creating the tunnel below will trigger a net subsystem event
- # prevent it from touching or iface by disabling .auto here
- uci_set_state network "$cfg" ifname $link
- uci_set_state network "$cfg" auto 0
+ test_6to4_rfc1918 "$local4" && {
+ tun_error "INVALID_LOCAL_ADDRESS"
+ return
+ }
- # find our local prefix
- local prefix6=$(find_6to4_prefix "$local4")
- local local6="$prefix6::1/16"
+ # find our local prefix
+ local prefix6=$(find_6to4_prefix "$local4")
+ local local6="$prefix6::1"
- logger -t "$link" " * IPv4 address is $local4"
- logger -t "$link" " * IPv6 address is $local6"
- ip tunnel add $link mode sit remote any local $local4 ttl ${ttl:-64}
- ip link set $link up
- ip link set mtu ${mtu:-1280} dev $link
- ip addr add $local6 dev $link
+ proto_init_update "$link" 1
+ proto_add_ipv6_address "$local6" 16
+ proto_add_ipv6_route "::" 0
- uci_set_state network "$cfg" ipaddr $local4
- uci_set_state network "$cfg" ip6addr $local6
+ proto_add_tunnel
+ json_add_string mode sit
+ json_add_int mtu "${mtu:-1280}"
+ json_add_int ttl "${ttl:-64}"
+ json_add_string local "$local4"
+ json_add_string remote "192.88.99.1"
+ proto_close_tunnel
- [ "$defaultroute" = 1 ] && {
- logger -t "$link" " * Adding default route"
- ip -6 route add 2000::/3 via ::192.88.99.1 dev $link metric 1
- uci_set_state network "$cfg" defaultroute 1
- }
+ proto_send_update "$cfg"
+
+ [ -f /etc/config/radvd ] && /etc/init.d/radvd enabled && {
+ local sid="6to4_$cfg"
+
+ uci_revert_state radvd
+ config_load radvd
+
+ adv_subnet=$((0x${adv_subnet:-1}))
- # find delegation target
- local adv_interface
- config_get adv_interface "$cfg" adv_interface
-
- local adv_ifname
- config_get adv_ifname "${adv_interface:-lan}" ifname
-
- local adv_subnet=$(uci_get network "$cfg" adv_subnet)
-
- grep -qs "^ *$adv_ifname:" /proc/net/dev && {
- local subnet6="$prefix6:${adv_subnet:-1}::1/64"
-
- logger -t "$link" " * Advertising IPv6 subnet $subnet6 on ${adv_interface:-lan} ($adv_ifname)"
- ip -6 addr add $subnet6 dev $adv_ifname
- uci_set_state network "$cfg" adv_subnet "$subnet6"
- uci_set_state network "$cfg" adv_ifname "$adv_ifname"
-
- [ -f /etc/config/radvd ] && /etc/init.d/radvd enabled && {
- local sid="6to4_$cfg"
-
- uci -q batch <<-EOF
- delete radvd.iface_$sid
- delete radvd.prefix_$sid
- set radvd.iface_$sid=interface
- set radvd.iface_$sid.ignore=0
- set radvd.iface_$sid.interface=${adv_interface:-lan}
- set radvd.iface_$sid.IgnoreIfMissing=1
- set radvd.iface_$sid.AdvSendAdvert=1
- set radvd.iface_$sid.MaxRtrAdvInterval=30
- set radvd.prefix_$sid=prefix
- set radvd.prefix_$sid.ignore=0
- set radvd.prefix_$sid.interface=${adv_interface:-lan}
- set radvd.prefix_$sid.prefix=0:0:0:${adv_subnet:-1}::/64
- set radvd.prefix_$sid.AdvOnLink=1
- set radvd.prefix_$sid.AdvAutonomous=1
- set radvd.prefix_$sid.AdvValidLifetime=300
- set radvd.prefix_$sid.AdvPreferredLifetime=120
- set radvd.prefix_$sid.Base6to4Interface=$wancfg
- EOF
-
- /etc/init.d/radvd restart
+ local adv_subnets=""
+
+ for adv_interface in ${adv_interface:-lan}; do
+ local adv_ifname
+ config_get adv_ifname "${adv_interface:-lan}" ifname
+
+ grep -qs "^ *$adv_ifname:" /proc/net/dev && {
+ local subnet6="$(printf "%s:%x::1/64" "$prefix6" $adv_subnet)"
+
+ logger -t "$link" " * Advertising IPv6 subnet $subnet6 on ${adv_interface:-lan} ($adv_ifname)"
+ ip -6 addr add $subnet6 dev $adv_ifname
+
+ set_6to4_radvd_interface "$sid" "$adv_interface" "$mtu"
+ set_6to4_radvd_prefix "$sid" "$adv_interface" \
+ "$wancfg" "$(printf "0:0:0:%x::/64" $adv_subnet)" \
+ "$adv_valid_lifetime" "$adv_preferred_lifetime"
+
+ adv_subnets="${adv_subnets:+$adv_subnets }$adv_ifname:$subnet6"
+ adv_subnet=$(($adv_subnet + 1))
}
- }
+ done
- logger -t "$link" "... started"
+ uci_set_state network "$cfg" adv_subnets "$adv_subnets"
- env -i ACTION="ifup" INTERFACE="$cfg" DEVICE="$link" PROTO=6to4 /sbin/hotplug-call "iface" &
- } || {
- echo "Cannot determine local IPv4 address for 6to4 tunnel $cfg - skipping"
+ /etc/init.d/radvd restart
}
}
-stop_interface_6to4() {
+proto_6to4_teardown() {
local cfg="$1"
local link="6to4-$cfg"
- local local6=$(uci_get_state network "$cfg" ip6addr)
- local defaultroute=$(uci_get_state network "$cfg" defaultroute)
-
- local adv_subnet=$(uci_get_state network "$cfg" adv_subnet)
- local adv_ifname=$(uci_get_state network "$cfg" adv_ifname)
+ local adv_subnets=$(uci_get_state network "$cfg" adv_subnets)
grep -qs "^ *$link:" /proc/net/dev && {
- logger -t "$link" "Shutting down ..."
- env -i ACTION="ifdown" INTERFACE="$cfg" DEVICE="$link" PROTO=6to4 /sbin/hotplug-call "iface" &
-
- [ -n "$adv_subnet" ] && [ -n "$adv_ifname" ] && {
- local sid="6to4_$cfg"
-
- uci -q batch <<-EOF
- delete radvd.iface_$sid
- delete radvd.prefix_$sid
- EOF
-
+ [ -n "$adv_subnets" ] && {
+ uci_revert_state radvd
/etc/init.d/radvd enabled && /etc/init.d/radvd restart
-
- ip -6 addr del $adv_subnet dev $adv_ifname
- }
-
- [ "$defaultroute" = "1" ] && {
- ip -6 route del 2000::/3 via ::192.88.99.1 dev $link metric 1
}
+ }
+}
- ip addr del $local6 dev $link
- ip link set $link down
- ip tunnel del $link
+proto_6to4_init_config() {
+ no_device=1
+ available=1
+
+ proto_config_add_string "ipaddr"
+ proto_config_add_int "mtu"
+ proto_config_add_int "ttl"
+ proto_config_add_string "adv_interface"
+ proto_config_add_string "adv_subnet"
+ proto_config_add_int "adv_valid_lifetime"
+ proto_config_add_int "adv_preferred_lifetime"
+}
- logger -t "$link" "... stopped"
- }
+[ -n "$INCLUDE_ONLY" ] || {
+ add_protocol 6to4
}